SystemOrganization addCategory: #'PW-Xtreams-WikiParsing'!

PEGActor subclass: #PWWikiActor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PW-Xtreams-WikiParsing'!

!PWWikiActor commentStamp: 'chc 11/30/2016 11:16' prior: 0!
This class is adapted from PEG.WikiGenerator in Cincom's VisualWorks!

!PWWikiActor methodsFor: 'argument' stamp: 'chc 11/25/2015 19:27'!
Bold: flow
	<action: 'Bold' arguments: #(2)>
	^'<b>' , (self collectString: flow) , '</b>'! !

!PWWikiActor methodsFor: 'argument' stamp: 'chc 11/29/2016 09:57'!
Bullet1: flow
	<action: 'Bullet1' arguments: #(3)>
	<action: 'Bullet2' arguments: #(3)>
	<action: 'Bullet3' arguments: #(3)>
	^'<li>' , (self collectString: flow) , '</li>'! !

!PWWikiActor methodsFor: 'argument' stamp: 'chc 11/29/2016 09:57'!
Hash1: flow
	<action: 'Hash1' arguments: #(3)>
	<action: 'Hash2' arguments: #(3)>	
	<action: 'Hash3' arguments: #(3)>	
	^'<li>' , (self collectString: flow) , '</li>'! !

!PWWikiActor methodsFor: 'argument' stamp: 'chc 11/25/2015 19:27'!
Heading1: flow
	<action: 'Heading1' arguments: #(3) >
	^'<h1>' , (self collectString: flow) , '</h1>'! !

!PWWikiActor methodsFor: 'argument' stamp: 'chc 11/25/2015 19:27'!
Heading2: flow
	<action: 'Heading2' arguments: #(3) >
	^'<h2>' , (self collectString: flow) , '</h2>'! !

!PWWikiActor methodsFor: 'argument' stamp: 'chc 11/25/2015 19:27'!
Heading3: flow
	<action: 'Heading3' arguments: #(3) >
	^'<h3>' , (self collectString: flow) , '</h3>'! !

!PWWikiActor methodsFor: 'argument' stamp: 'chc 3/24/2016 09:54'!
Italic: flow
	<action: 'Italic' arguments: #(2)>
	^'<i>' , (self collectString: flow) , '</i>'
	
	"^(Character value: 16ra3) asString , (self collectString: flow) , (Character value: 16ra3) asString"! !

!PWWikiActor methodsFor: 'argument' stamp: 'chc 11/28/2016 10:54'!
Link: flow
	<action: 'LinkShort' arguments: #( 2 )>
	| filename |
	filename := self collectString: flow.
	^'<a href="' , filename , '.html">' , filename , '</a>'! !

!PWWikiActor methodsFor: 'argument' stamp: 'chc 11/28/2016 10:35'!
Link: flow address: address
	<action: 'LinkFull' arguments: #(2 3)>
	| stringargs|
	stringargs := {address . flow} collect: [:ea| self collectString: ea].
	^'<a href="' , (stringargs at: 1) , '">' , (stringargs at: 2) , '</a>'! !

!PWWikiActor methodsFor: 'no-argument' stamp: 'chc 11/29/2016 09:03'!
OrderedList: flow
	<action: 'OrderedList'>
	^'<ol>' , (self collectString: flow) , '</ol>'! !

!PWWikiActor methodsFor: 'no-argument' stamp: 'chc 11/29/2016 10:19'!
OrderedListN: flow
	<action: 'OrderedList2'>
	<action: 'OrderedList3'>
	| string |
	string := String new writing.
	flow do: [:ea| string write: ('<ol>' , ea , '</ol>')].
	^string conclusion
! !

!PWWikiActor methodsFor: 'no-argument' stamp: 'chc 1/2/2016 13:19'!
Page: flow
	<action: 'Page'>
	^'<div>' , (self collectString: flow) , '</div>'! !

!PWWikiActor methodsFor: 'no-argument' stamp: 'chc 11/25/2015 19:28'!
Paragraph: flow
	<action: 'Paragraph'>
	^'<p>' , (self collectString: flow) , '</p>'! !

!PWWikiActor methodsFor: 'argument' stamp: 'chc 11/30/2016 10:11'!
Preformatted: flow
	<action: 'Preformatted' arguments: #(2)>
	<action: 'Code' arguments: #(2)>
	^'<pre>' , (self collectString: flow) , '</pre>'! !

!PWWikiActor methodsFor: 'argument' stamp: 'chc 11/30/2016 10:36'!
Table: header rows: rows
	<action: 'Table' arguments: #(1 2)>
	| allrows |
	allrows := String new writing.
	rows do: [:ea|  allrows write: ea].
	^'<table>' , header , allrows conclusion , '</table>'! !

!PWWikiActor methodsFor: 'no-argument' stamp: 'chc 11/30/2016 10:34'!
TableCell: flow
	<action: 'Cell'>
	^'<td>' , (self collectString: flow) , '</td>'! !

!PWWikiActor methodsFor: 'no-argument' stamp: 'chc 11/30/2016 10:28'!
TableHeadingCell: flow
	<action: 'HeadingCell'>
	^'<th>' , (self collectString: flow) , '</th>'! !

!PWWikiActor methodsFor: 'argument' stamp: 'chc 11/30/2016 10:32'!
TableRow: flow
	<action: 'TableRow' arguments: #(3)>
	<action: 'HeadingRow' arguments: #(3)>
	^'<tr>' , (self collectString: flow) , '</tr>'! !

!PWWikiActor methodsFor: 'no-argument' stamp: 'chc 11/29/2016 09:15'!
UnorderedList: flow
	<action: 'UnorderedList'>
	^'<ul>' , (self collectString: flow) , '</ul>'! !

!PWWikiActor methodsFor: 'no-argument' stamp: 'chc 11/29/2016 10:18'!
UnorderedListN: flow
	<action: 'UnorderedList2'>
	<action: 'UnorderedList3'>
	| string |
	string := String new writing.
	flow do: [:ea| string write: ('<ul>' , ea , '</ul>')].
	^string conclusion
! !

!PWWikiActor methodsFor: 'private' stamp: 'chc 11/29/2016 09:28'!
collectString: flow
	| string |
	string := String new writing.
	flow do: [:ea| string write: ea].
	^string conclusion! !

TestCase subclass: #PWParserWikiTest
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PW-Xtreams-WikiParsing'!

!PWParserWikiTest commentStamp: 'chc 11/30/2016 11:10' prior: 0!
This test is adapted from PEG.ParserWikiTest in Cincom's VisualWorks!

!PWParserWikiTest methodsFor: 'as yet unclassified' stamp: 'chc 11/25/2016 10:46'!
setUp
	parser := PEGParser parserWiki! !

!PWParserWikiTest methodsFor: 'as yet unclassified' stamp: 'chc 11/30/2016 11:15'!
testHeading
	| input output |
"This test is adapted from PEG.ParserWikiTest in Cincom's VisualWorks"
	input :=
'	= Hello _World_ =
Good _Bye_ *[World>http://www.google.com]*

[Short-Link]
* Bullet1 < Bullet2
* Bullet2
# Numbered
## Nested
---
	preformatted text
---
{{{
	code
}}}
and again
	|| Heading1 || Heading2
	|| Data 1 || Data2
	|| Data 3 || Data4
After table'.
output := parser parse: 'Page' stream: input reading actor: PWWikiActor new.
	self assert: output  =  '<div><h1>Hello <i>World</i></h1><p>Good <i>Bye</i> <b><a href="http://www.google.com">World</a></b></p>
<p><a href="Short-Link.html">Short-Link</a></p><ul><li> Bullet1 < Bullet2</li><li> Bullet2</li></ul><ol><li> Numbered</li><ol><li> Nested</li></ol></ol><pre>	preformatted text
</pre><pre>	code
</pre><p>and again</p><table><tr><th> Heading1 </th><th> Heading2</th></tr><tr><td> Data 1 </td><td> Data2</td></tr><tr><td> Data 3 </td><td> Data4</td></tr></table><p>After table</p></div>'! !
